[Author Prev][Author Next][Thread Prev][Thread Next][Author Index][Thread Index]
[tor-commits] [weather/master] - Added a init.d style script to start/stop the listener process
commit 357efba19df13dd2c27dee3879c3173e0041b080
Author: Christian Fromme <kaner@xxxxxxxxxx>
Date: Mon Nov 12 13:29:05 2012 +0100
- Added a init.d style script to start/stop the listener process
- On Bahri, this script is used to restart the listener process
once per week currently. This is necessary to work around some
bug where Weather doesn't parse new consensuses anymore.
- Fixed a typo in fingerprint_not_found.html (Thanks, arma)
- Renamed the manager script from manage.py to weathercontrol.py.
Names are important. ;-)
---
weather/manage.py | 11 --
weather/scripts/weather | 153 ++++++++++++++++++++++++++
weather/templates/fingerprint_not_found.html | 2 +-
weather/weathercontrol.py | 11 ++
4 files changed, 165 insertions(+), 12 deletions(-)
diff --git a/weather/manage.py b/weather/manage.py
deleted file mode 100755
index bcdd55e..0000000
--- a/weather/manage.py
+++ /dev/null
@@ -1,11 +0,0 @@
-#!/usr/bin/python
-from django.core.management import execute_manager
-try:
- import settings # Assumed to be in the same directory.
-except ImportError:
- import sys
- sys.stderr.write("Error: Can't find the file 'settings.py' in the directory containing %r. It appears you've customized things.\nYou'll have to run django-admin.py, passing it your settings module.\n(If the file settings.py does indeed exist, it's causing an ImportError somehow.)\n" % __file__)
- sys.exit(1)
-
-if __name__ == "__main__":
- execute_manager(settings)
diff --git a/weather/scripts/weather b/weather/scripts/weather
new file mode 100755
index 0000000..5119056
--- /dev/null
+++ b/weather/scripts/weather
@@ -0,0 +1,153 @@
+#! /bin/sh
+### BEGIN INIT INFO
+# Provides: tor_weather
+# Required-Start: $remote_fs $syslog
+# Required-Stop: $remote_fs $syslog
+# Default-Start: 2 3 4 5
+# Default-Stop: 0 1 6
+# Short-Description: Control The Tor Weather Listener Process
+# Description: See Short-Description.
+### END INIT INFO
+
+# Author: Christian Fromme <kaner@xxxxxxxxxxxxxx>
+#
+
+# PATH should only include /usr/* if it runs after the mountnfs.sh script
+PATH=/sbin:/usr/sbin:/bin:/usr/bin
+DESC="Tor Weather Daemon"
+NAME=weathercontrol.py
+DAEMON=/home/weather/opt/current/weather/$NAME
+DAEMON_ARGS=" runlistener"
+PIDFILE=/home/weather/var/run/$NAME.pid
+SCRIPTNAME=/home/weather/bin/weather
+
+# Exit if the package is not installed
+[ -x "$DAEMON" ] || exit 0
+
+# Read configuration variable file if it is present
+[ -r /etc/default/$NAME ] && . /etc/default/$NAME
+
+# Load the VERBOSE setting and other rcS variables
+. /lib/init/vars.sh
+
+# Define LSB log_* functions.
+# Depend on lsb-base (>= 3.2-14) to ensure that this file is present
+# and status_of_proc is working.
+. /lib/lsb/init-functions
+
+#
+# Function that starts the daemon/service
+#
+do_start()
+{
+ # Return
+ # 0 if daemon has been started
+ # 1 if daemon was already running
+ # 2 if daemon could not be started
+ start-stop-daemon --start --quiet --chdir /home/weather/opt/current/weather --pidfile $PIDFILE --exec $DAEMON --make-pidfile --background --test > /dev/null \
+ || return 1
+ start-stop-daemon --start --quiet --chdir /home/weather/opt/current/weather --pidfile $PIDFILE --exec $DAEMON --make-pidfile --background -- \
+ $DAEMON_ARGS \
+ || return 2
+ # Add code here, if necessary, that waits for the process to be ready
+ # to handle requests from services started subsequently which depend
+ # on this one. As a last resort, sleep for some time.
+}
+
+#
+# Function that stops the daemon/service
+#
+do_stop()
+{
+ # Return
+ # 0 if daemon has been stopped
+ # 1 if daemon was already stopped
+ # 2 if daemon could not be stopped
+ # other if a failure occurred
+ start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE
+ RETVAL="$?"
+ [ "$RETVAL" = 2 ] && return 2
+ # Wait for children to finish too if this is a daemon that forks
+ # and if the daemon is only ever run from this initscript.
+ # If the above conditions are not satisfied then add some other code
+ # that waits for the process to drop all resources that could be
+ # needed by services started subsequently. A last resort is to
+ # sleep for some time.
+ start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
+ [ "$?" = 2 ] && return 2
+ # Many daemons don't delete their pidfiles when they exit.
+ rm -f $PIDFILE
+ return "$RETVAL"
+}
+
+#
+# Function that sends a SIGHUP to the daemon/service
+#
+do_reload() {
+ #
+ # If the daemon can reload its configuration without
+ # restarting (for example, when it is sent a SIGHUP),
+ # then implement that here.
+ #
+ start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
+ return 0
+}
+
+case "$1" in
+ start)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$NAME"
+ do_start
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ stop)
+ [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
+ 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
+ esac
+ ;;
+ status)
+ status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $?
+ ;;
+ #reload|force-reload)
+ #
+ # If do_reload() is not implemented then leave this commented out
+ # and leave 'force-reload' as an alias for 'restart'.
+ #
+ #log_daemon_msg "Reloading $DESC" "$NAME"
+ #do_reload
+ #log_end_msg $?
+ #;;
+ restart|force-reload)
+ #
+ # If the "reload" option is implemented then remove the
+ # 'force-reload' alias
+ #
+ log_daemon_msg "Restarting $DESC" "$NAME"
+ do_stop
+ case "$?" in
+ 0|1)
+ do_start
+ case "$?" in
+ 0) log_end_msg 0 ;;
+ 1) log_end_msg 1 ;; # Old process is still running
+ *) log_end_msg 1 ;; # Failed to start
+ esac
+ ;;
+ *)
+ # Failed to stop
+ log_end_msg 1
+ ;;
+ esac
+ ;;
+ *)
+ echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2
+ exit 3
+ ;;
+esac
+
+:
diff --git a/weather/templates/fingerprint_not_found.html b/weather/templates/fingerprint_not_found.html
index f50e41f..b90d32c 100644
--- a/weather/templates/fingerprint_not_found.html
+++ b/weather/templates/fingerprint_not_found.html
@@ -14,7 +14,7 @@
<li>The fingerprint was entered incorrectly</li>
<li>The node with the given fingerprint was set up within the last hour, in which case you should try to register again a bit later</li>
<li>The node with the given fingerprint has been down for over a year</li>
- <li>The node you are trying to monitor is running on a <em>very</em> out of date verion of Tor (version 0.1.0.5 or earlier) and doesn't publish its fingerprint to the directory authorities.</li>
+ <li>The node you are trying to monitor is running on a <em>very</em> out of date version of Tor (version 0.1.0.5 or earlier) and doesn't publish its fingerprint to the directory authorities.</li>
</ul>
</p>
{% endblock %}
diff --git a/weather/weathercontrol.py b/weather/weathercontrol.py
new file mode 100755
index 0000000..bcdd55e
--- /dev/null
+++ b/weather/weathercontrol.py
@@ -0,0 +1,11 @@
+#!/usr/bin/python
+from django.core.management import execute_manager
+try:
+ import settings # Assumed to be in the same directory.
+except ImportError:
+ import sys
+ sys.stderr.write("Error: Can't find the file 'settings.py' in the directory containing %r. It appears you've customized things.\nYou'll have to run django-admin.py, passing it your settings module.\n(If the file settings.py does indeed exist, it's causing an ImportError somehow.)\n" % __file__)
+ sys.exit(1)
+
+if __name__ == "__main__":
+ execute_manager(settings)
_______________________________________________
tor-commits mailing list
tor-commits@xxxxxxxxxxxxxxxxxxxx
https://lists.torproject.org/cgi-bin/mailman/listinfo/tor-commits